"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HillResultMapper = void 0;
class HillResultMapper {
    mapMatchResultsToWarriors(warrior, allResults) {
        const matches = allResults.filter(x => !!x.results.find(y => y.warrior.internalId === warrior.internalId));
        const results = matches.flatMap(x => x.results.filter(y => y.warrior.internalId === warrior.internalId));
        const won = results.reduce((accum, result) => accum + result.won, 0) / results.length;
        const drawn = results.reduce((accum, result) => accum + result.drawn, 0) / results.length;
        const lost = results.reduce((accum, result) => accum + result.lost, 0) / results.length;
        return {
            warrior,
            rank: 0,
            score: won * 3 + drawn,
            won,
            drawn,
            lost,
            matches
        };
    }
    map(warriors, allResults) {
        const warriorResults = warriors.map(warrior => this.mapMatchResultsToWarriors(warrior, allResults));
        const sortedResults = warriorResults.sort((a, b) => b.score - a.score);
        return {
            warriors: sortedResults.map((x, idx) => (Object.assign(Object.assign({}, x), { rank: idx + 1 })))
        };
    }
}
exports.HillResultMapper = HillResultMapper;
//# sourceMappingURL=HillResultMapper.js.map