"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HillRunner = void 0;
const IMessage_1 = require("../simulator/interface/IMessage");
class HillRunner {
    constructor(publisher, matchRunner, hillResultMapper) {
        this.publisher = publisher;
        this.matchRunner = matchRunner;
        this.hillResultMapper = hillResultMapper;
    }
    publishEnd(result) {
        this.publisher.queue({
            type: IMessage_1.MessageType.HillEnd,
            payload: result
        });
        this.publisher.publish();
    }
    run(rules, warriors) {
        const matchResults = [];
        for (let i = 0; i < warriors.length; i++) {
            if (typeof warriors[i].internalId === 'undefined') {
                warriors[i].internalId = i;
            }
        }
        for (const warriorA of warriors) {
            for (const warriorB of warriors) {
                if (warriorA === warriorB) {
                    continue;
                }
                matchResults.push(this.matchRunner.run(rules, [warriorA, warriorB]));
            }
        }
        const result = this.hillResultMapper.map(warriors, matchResults);
        this.publishEnd(result);
        return result;
    }
}
exports.HillRunner = HillRunner;
//# sourceMappingURL=HillRunner.js.map