"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MatchResultMapper = void 0;
class MatchResultMapper {
    getWarriorResult(warrior, roundResults) {
        const rounds = roundResults.length;
        const won = roundResults.filter(r => r.outcome === 'WIN' && r.winnerId === warrior.internalId).length;
        const lost = roundResults.filter(r => r.outcome === 'WIN' && r.winnerId !== warrior.internalId).length;
        const drawn = rounds - won - lost;
        const winpoints = (won / rounds) * 100 * 3;
        const drawpoints = (drawn / rounds) * 100 * 1;
        const losepoints = (lost / rounds) * 100 * 3;
        return {
            warrior,
            won,
            drawn,
            lost,
            given: losepoints + drawpoints,
            taken: winpoints + drawpoints
        };
    }
    map(warriors, roundResults) {
        return {
            rounds: roundResults.length,
            results: warriors.map(warrior => this.getWarriorResult(warrior, roundResults))
        };
    }
}
exports.MatchResultMapper = MatchResultMapper;
//# sourceMappingURL=MatchResultMapper.js.map