"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Context = void 0;
class Context {
    constructor() {
        this.metaData = {
            name: '',
            author: '',
            strategy: ''
        };
        this.equs = {};
        this.tokens = [];
        this.labels = {};
        this.messages = [];
    }
    emitSingle(token) {
        this.tokens.push(token);
    }
    emit(tokens) {
        this.tokens = this.tokens.concat(tokens);
    }
    emitInstruction(instruction) {
        if (instruction.opcode != null) {
            this.tokens.push(instruction.opcode);
        }
        if (instruction.modifier != null) {
            this.tokens.push(instruction.modifier);
        }
        if (instruction.aOperand != null) {
            if (instruction.aOperand.mode != null) {
                this.tokens.push(instruction.aOperand.mode);
            }
            if (instruction.aOperand.address != null) {
                this.tokens.push(instruction.aOperand.address);
            }
        }
        if (instruction.comma != null) {
            this.tokens.push(instruction.comma);
        }
        if (instruction.bOperand != null) {
            if (instruction.bOperand.mode != null) {
                this.tokens.push(instruction.bOperand.mode);
            }
            if (instruction.bOperand.address != null) {
                this.tokens.push(instruction.bOperand.address);
            }
        }
        if (instruction.comment != null) {
            this.tokens.push(instruction.comment);
        }
        if (instruction.eol != null) {
            this.tokens.push(instruction.eol);
        }
    }
}
exports.Context = Context;
//# sourceMappingURL=Context.js.map