"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PerKeyStrategy = void 0;
class PerKeyStrategy {
    constructor(key) {
        this.payloads = {};
        this.key = key;
    }
    queue(message) {
        this.type = message.type;
        this.payloads[this.key(message.payload)] = message.payload;
    }
    dequeue() {
        const payloads = Object.keys(this.payloads).map(k => this.payloads[k]);
        if (payloads.length === 0) {
            return null;
        }
        return {
            type: this.type,
            payload: payloads
        };
    }
    clear() {
        this.payloads = {};
    }
}
exports.PerKeyStrategy = PerKeyStrategy;
//# sourceMappingURL=PerKeyStrategy.js.map